Merge tag 'for_linus' of git://git.kernel.org/pub/scm/linux/kernel/git/mst/vhost
[cris-mirror.git] / scripts / kconfig / Makefile
blobcb3ec53a7c29f2e086aa72c6659f63ae76f2523f
1 # SPDX-License-Identifier: GPL-2.0
2 # ===========================================================================
3 # Kernel configuration targets
4 # These targets are used from top-level makefile
6 PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
7 localmodconfig localyesconfig
9 ifdef KBUILD_KCONFIG
10 Kconfig := $(KBUILD_KCONFIG)
11 else
12 Kconfig := Kconfig
13 endif
15 ifeq ($(quiet),silent_)
16 silent := -s
17 endif
19 # We need this, in case the user has it in its environment
20 unexport CONFIG_
22 xconfig: $(obj)/qconf
23 $< $(silent) $(Kconfig)
25 gconfig: $(obj)/gconf
26 $< $(silent) $(Kconfig)
28 menuconfig: $(obj)/mconf
29 $< $(silent) $(Kconfig)
31 config: $(obj)/conf
32 $< $(silent) --oldaskconfig $(Kconfig)
34 nconfig: $(obj)/nconf
35 $< $(silent) $(Kconfig)
37 # This has become an internal implementation detail and is now deprecated
38 # for external use.
39 silentoldconfig: $(obj)/conf
40 $(Q)mkdir -p include/config include/generated
41 $(Q)test -e include/generated/autoksyms.h || \
42 touch include/generated/autoksyms.h
43 $< $(silent) --$@ $(Kconfig)
45 localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
46 $(Q)mkdir -p include/config include/generated
47 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
48 $(Q)if [ -f .config ]; then \
49 cmp -s .tmp.config .config || \
50 (mv -f .config .config.old.1; \
51 mv -f .tmp.config .config; \
52 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
53 mv -f .config.old.1 .config.old) \
54 else \
55 mv -f .tmp.config .config; \
56 $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
58 $(Q)rm -f .tmp.config
60 # Create new linux.pot file
61 # Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
62 update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
63 $(Q)$(kecho) " GEN config.pot"
64 $(Q)xgettext --default-domain=linux \
65 --add-comments --keyword=_ --keyword=N_ \
66 --from-code=UTF-8 \
67 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
68 --directory=$(srctree) --directory=$(objtree) \
69 --output $(obj)/config.pot
70 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
71 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
72 $(srctree)/arch/*/um/Kconfig`; \
73 do \
74 $(kecho) " GEN $$i"; \
75 $(obj)/kxgettext $$i \
76 >> $(obj)/config.pot; \
77 done )
78 $(Q)$(kecho) " GEN linux.pot"
79 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
80 --output $(obj)/linux.pot
81 $(Q)rm -f $(obj)/config.pot
83 # These targets map 1:1 to the commandline options of 'conf'
84 simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
85 alldefconfig randconfig listnewconfig olddefconfig
86 PHONY += $(simple-targets)
88 $(simple-targets): $(obj)/conf
89 $< $(silent) --$@ $(Kconfig)
91 PHONY += oldnoconfig savedefconfig defconfig
93 # oldnoconfig is an alias of olddefconfig, because people already are dependent
94 # on its behavior (sets new symbols to their default value but not 'n') with the
95 # counter-intuitive name.
96 oldnoconfig: olddefconfig
97 @echo " WARNING: \"oldnoconfig\" target will be removed after Linux 4.19"
98 @echo " Please use \"olddefconfig\" instead, which is an alias."
100 savedefconfig: $(obj)/conf
101 $< $(silent) --$@=defconfig $(Kconfig)
103 defconfig: $(obj)/conf
104 ifeq ($(KBUILD_DEFCONFIG),)
105 $< $(silent) --defconfig $(Kconfig)
106 else
107 ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
108 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
109 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
110 else
111 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
112 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
113 endif
114 endif
116 %_defconfig: $(obj)/conf
117 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
119 configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
121 %.config: $(obj)/conf
122 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
123 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
124 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
126 PHONY += kvmconfig
127 kvmconfig: kvm_guest.config
130 PHONY += xenconfig
131 xenconfig: xen.config
134 PHONY += tinyconfig
135 tinyconfig:
136 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
138 # Help text used by make help
139 help:
140 @echo ' config - Update current config utilising a line-oriented program'
141 @echo ' nconfig - Update current config utilising a ncurses menu based'
142 @echo ' program'
143 @echo ' menuconfig - Update current config utilising a menu based program'
144 @echo ' xconfig - Update current config utilising a Qt based front-end'
145 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
146 @echo ' oldconfig - Update current config utilising a provided .config as base'
147 @echo ' localmodconfig - Update current config disabling modules not loaded'
148 @echo ' localyesconfig - Update current config converting local mods to core'
149 @echo ' defconfig - New config with default from ARCH supplied defconfig'
150 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
151 @echo ' allnoconfig - New config where all options are answered with no'
152 @echo ' allyesconfig - New config where all options are accepted with yes'
153 @echo ' allmodconfig - New config selecting modules when possible'
154 @echo ' alldefconfig - New config with all symbols set to default'
155 @echo ' randconfig - New config with random answer to all options'
156 @echo ' listnewconfig - List new options'
157 @echo ' olddefconfig - Same as oldconfig but sets new symbols to their'
158 @echo ' default value without prompting'
159 @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
160 @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
161 @echo ' tinyconfig - Configure the tiniest possible kernel'
163 # lxdialog stuff
164 check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
166 # Use recursively expanded variables so we do not call gcc unless
167 # we really need to do so. (Do not call gcc as part of make mrproper)
168 HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
169 -DLOCALE
171 # ===========================================================================
172 # Shared Makefile for the various kconfig executables:
173 # conf: Used for defconfig, oldconfig and related targets
174 # nconf: Used for the nconfig target.
175 # Utilizes ncurses
176 # mconf: Used for the menuconfig target
177 # Utilizes the lxdialog package
178 # qconf: Used for the xconfig target
179 # Based on Qt which needs to be installed to compile it
180 # gconf: Used for the gconfig target
181 # Based on GTK+ which needs to be installed to compile it
182 # object files used by all kconfig flavours
184 lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
185 lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
187 conf-objs := conf.o zconf.tab.o
188 mconf-objs := mconf.o zconf.tab.o $(lxdialog)
189 nconf-objs := nconf.o zconf.tab.o nconf.gui.o
190 kxgettext-objs := kxgettext.o zconf.tab.o
191 qconf-cxxobjs := qconf.o
192 qconf-objs := zconf.tab.o
193 gconf-objs := gconf.o zconf.tab.o
195 hostprogs-y := conf nconf mconf kxgettext qconf gconf
197 targets += zconf.tab.c zconf.lex.c
198 clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
199 clean-files += zconf.tab.c zconf.lex.c gconf.glade.h
200 clean-files += config.pot linux.pot
202 # Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
203 PHONY += $(obj)/dochecklxdialog
204 $(addprefix $(obj)/, mconf.o $(lxdialog)): $(obj)/dochecklxdialog
205 $(obj)/dochecklxdialog:
206 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
208 always := dochecklxdialog
210 # Add environment specific flags
211 HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
212 HOST_EXTRACXXFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCXX) $(HOSTCXXFLAGS))
214 # generated files seem to need this to find local include files
215 HOSTCFLAGS_zconf.lex.o := -I$(src)
216 HOSTCFLAGS_zconf.tab.o := -I$(src)
218 HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
219 HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
221 HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
222 HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
223 -Wno-missing-prototypes
225 HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
227 HOSTLOADLIBES_nconf = $(shell \
228 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
229 || pkg-config --libs menu panel ncurses 2>/dev/null \
230 || echo "-lmenu -lpanel -lncurses" )
231 $(obj)/qconf.o: $(obj)/.tmp_qtcheck
233 ifeq ($(MAKECMDGOALS),xconfig)
234 $(obj)/.tmp_qtcheck: $(src)/Makefile
235 -include $(obj)/.tmp_qtcheck
237 # Qt needs some extra effort...
238 $(obj)/.tmp_qtcheck:
239 @set -e; $(kecho) " CHECK qt"; \
240 if pkg-config --exists Qt5Core; then \
241 cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
242 libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
243 moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
244 elif pkg-config --exists QtCore; then \
245 cflags=`pkg-config --cflags QtCore QtGui`; \
246 libs=`pkg-config --libs QtCore QtGui`; \
247 moc=`pkg-config --variable=moc_location QtCore`; \
248 else \
249 echo >&2 "*"; \
250 echo >&2 "* Could not find Qt via pkg-config."; \
251 echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
252 echo >&2 "*"; \
253 exit 1; \
254 fi; \
255 echo "KC_QT_CFLAGS=$$cflags" > $@; \
256 echo "KC_QT_LIBS=$$libs" >> $@; \
257 echo "KC_QT_MOC=$$moc" >> $@
258 endif
260 $(obj)/gconf.o: $(obj)/.tmp_gtkcheck
262 ifeq ($(MAKECMDGOALS),gconfig)
263 -include $(obj)/.tmp_gtkcheck
265 # GTK+ needs some extra effort, too...
266 $(obj)/.tmp_gtkcheck:
267 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
268 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
269 touch $@; \
270 else \
271 echo >&2 "*"; \
272 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
273 echo >&2 "*"; \
274 false; \
275 fi \
276 else \
277 echo >&2 "*"; \
278 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
279 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
280 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
281 echo >&2 "*"; \
282 false; \
284 endif
286 $(obj)/zconf.tab.o: $(obj)/zconf.lex.c
288 $(obj)/qconf.o: $(obj)/qconf.moc
290 quiet_cmd_moc = MOC $@
291 cmd_moc = $(KC_QT_MOC) -i $< -o $@
293 $(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
294 $(call cmd,moc)
296 # Extract gconf menu items for i18n support
297 $(obj)/gconf.glade.h: $(obj)/gconf.glade
298 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
299 $(obj)/gconf.glade